image: node:10.22


stages:
  - deploy
  
dist:staging:
  stage: deploy
  environment: staging
  only:
    - master
  script:
    - echo -n "+ current working path:" && pwd
    - echo -n "+ node version:" && node --version
    - npm i -g npm@6.14.7
    - echo -n "+ npm version:" && npm --version
    - npm i -g --no-optional firebase-tools@8.9.2
    - echo -n "+ firebase-tools version:" && firebase --version
    - npm i --only=dev
    - cd functions
    - npm i --only=dev
    - npm i
    - cd ..
    - firebase functions:config:set chatnotifications.sendgridtemplateid="$SENDGRID_TEMPLATE_ID" -P staging --token $FIREBASE_TOKEN_STAGING
    - firebase functions:config:set chatnotifications.sendgridapikey="$SENDGRID_API_KEY" -P staging --token $FIREBASE_TOKEN_STAGING
    - firebase deploy --token $FIREBASE_TOKEN_STAGING -P staging --only functions:chatEmailNotifications
    
dist:production:
  stage: deploy
  environment: production
  only:
    - master
  when: manual    
  script:
    - echo -n "+ current working path:" && pwd
    - echo -n "+ node version:" && node --version
    - npm i -g npm@6.14.7
    - echo -n "+ npm version:" && npm --version
    - npm i -g --no-optional firebase-tools@8.9.2
    - echo -n "+ firebase-tools version:" && firebase --version
    - npm i --only=dev
    - cd functions
    - npm i --only=dev
    - npm i
    - cd ..
    - firebase functions:config:set chatnotifications.sendgridtemplateid="$SENDGRID_TEMPLATE_ID" -P prod --token $FIREBASE_TOKEN_PRODUCTION
    - firebase functions:config:set chatnotifications.sendgridapikey="$SENDGRID_API_KEY" -P prod --token $FIREBASE_TOKEN_PRODUCTION
    - firebase deploy --token $FIREBASE_TOKEN_PRODUCTION -P prod --only functions:chatEmailNotifications
